Subject: Re: [PATCH net-next v3 02/11] net: phy: introduce phy_has_c45_registers()

From: Michael Walle <[email-masked]>
Date: Tue, 01 Aug 2023 17:20:22 +0200

Hi,

>> > > > diff --git a/drivers/net/phy/phy-core.c b/drivers/net/phy/phy-core.c
>> > > > index a64186dc53f8..686a57d56885 100644
>> > > > --- a/drivers/net/phy/phy-core.c
>> > > > +++ b/drivers/net/phy/phy-core.c
>> > > > @@ -556,7 +556,7 @@ int __phy_read_mmd(struct phy_device
>> > > > *phydev, int devad, u32 regnum)
>> > > >
>> > > >  	if (phydev->drv && phydev->drv->read_mmd) {
>> > > >  		val = phydev->drv->read_mmd(phydev, devad, regnum);
>> > > > -	} else if (phydev->is_c45) {
>> > > > +	} else if (phy_has_c45_registers(phydev)) {
>> > >
>> > > This i would say should be
>> > >
>> > > phy_has_c45_transfers(phydev). This is about, can we do C45 transfers
>> > > on the bus, and if not, fall back to C45 over C22.
>> >
>> > Shouldn't this then be a bus property? I.e. mdiobus_has_c45_transfers().
>> > I've have a similar helper introduced in 9/11:
>> >
>> > static inline bool mdiobus_supports_c45(struct mii_bus *bus)
>> > {
>> >     return bus->read_c45 && !bus->prevent_c45_access;
>> > }
> 
> In the case of the above (the code in __phy_read_mmd()), I wouldn't
> at least initially change the test there.
> 
> phydev->is_c45 will only be true if we probed the PHY using clause
> 45 accesses. Thus, it will be set if "the bus supports clause 45
> accesses" _and_ "the PHY responds to those accesses".
> 
> Changing that to only "the bus supports clause 45 accesses" means
> that a PHY supporting only clause 22 access with indirect clause
> 45 access then fails if it's used with a bus that supports both
> clause 22 and clause 45 accesses.

Yeah of course. It was more about the naming, but I just realized
that with mdiobus_supports_c45() you can't access the original
"is_c45" property of the PHY. So maybe this patch needs to be split
into two to get rid of .is_c45:

First a mechanical one:
phy_has_c45_registers() {
    return phydev->is_c45;
}

phy_has_c22_registers() {
   return !phydev->is_c45;
}

For all the places Andrew said it's correct. Leave all the
other uses of .is_c45 as is for now and rework them in a
later patch to use mdiobus_supports_{c22,c45}().

-michael